; c2p conversion
; Obtains pixel registers
; Returns pixel registers one by one

; Input: a0: in, a1: out, d0: modulo (also size)

    xdef	_c2p

_c2p:

    movem.l	d2-d7/a2-a6,-(a7)
    
; Get args

    movea.l	a1,a5
    pea		(a1,d0.w)
    movea.w	d0,a6

; Load masks

    move.l	#$ff00ff00,a1
    move.l	#$55555555,a2
    move.l	#$33333333,a3
    move.l	#$0f0f0f0f,a4

; Loop

.loop:
    
    pea		4(a5)
    
    move.l	a4,d7

    move.l	(a0)+,d2
    move.l	d2,d0
    move.l	(a0)+,d3
    move.l	d3,d1
    and.l	d7,d2
    and.l	d7,d1
    eor.l	d2,d0
    eor.l	d1,d3
    lsl.l	#4,d2
    lsr.l	#4,d3
    or.l	d1,d2
    or.l	d0,d3
    move.l	d3,-(a7)

    move.l	(a0)+,d3
    move.l	d3,d0
    move.l	(a0)+,d4
    move.l	d4,d1
    and.l	d7,d3
    and.l	d7,d1
    eor.l	d3,d0
    eor.l	d1,d4
    lsl.l	#4,d3
    lsr.l	#4,d4
    or.l	d1,d3
    or.l	d0,d4
    move.l	d4,-(a7)

    move.l	(a0)+,d4
    move.l	d4,d0
    move.l	(a0)+,d5
    move.l	d5,d1
    and.l	d7,d4
    and.l	d7,d1
    eor.l	d4,d0
    eor.l	d1,d5
    lsl.l	#4,d4
    lsr.l	#4,d5
    or.l	d1,d4
    or.l	d0,d5
    move.l	d5,-(a7)

    move.l	(a0)+,d5
    move.l	d5,d0
    move.l	(a0)+,d6
    and.l	d7,d5
    and.l	d6,d7
    eor.l	d5,d0
    eor.l	d7,d6
    lsl.l	#4,d5
    lsr.l	#4,d6
    or.l	d7,d5
    eor.l	d0,d6
    move.l	d6,-(a7)

    move.l	a1,d7

    move.l	d2,d0
    move.l	d3,d1
    and.l	d7,d2
    and.l	d7,d1
    eor.l	d2,d0
    eor.l	d1,d3
    lsr.l	#8,d1
    lsl.l	#8,d0
    or.l	d1,d2
    or.l	d0,d3

    move.l	d4,d0
    and.l	d7,d4
    and.l	d5,d7
    eor.l	d4,d0
    eor.l	d7,d5
    lsr.l	#8,d7
    lsl.l	#8,d0
    or.l	d7,d4
    or.l	d0,d5

    move.l	a2,d7

    move.l	d2,d0
    move.l	d3,d1
    and.l	d7,d2
    and.l	d7,d1
    eor.l	d2,d0
    eor.l	d1,d3
    add.l	d2,d2
    lsr.l	#1,d3
    or.l	d1,d2
    or.l	d0,d3

    move.l	d4,d0
    and.l	d7,d4
    and.l	d5,d7
    eor.l	d4,d0
    eor.l	d7,d5
    add.l	d4,d4
    lsr.l	#1,d5
    or.l	d7,d4
    or.l	d0,d5

    swap	d4
    eor.w	d2,d4
    eor.w	d4,d2
    eor.w	d2,d4
    swap	d4

    swap	d5
    eor.w	d3,d5
    eor.w	d5,d3
    eor.w	d3,d5
    swap	d5

    move.l	a3,d7

    move.l	d2,d0
    move.l	d4,d1
    and.l	d7,d2
    and.l	d7,d1
    eor.l	d2,d0
    eor.l	d1,d4
    lsl.l	#2,d2
    lsr.l	#2,d4
    or.l	d1,d2
    or.l	d0,d4

    move.l	d3,d0
    and.l	d7,d3
    and.l	d5,d7
    eor.l	d3,d0
    eor.l	d7,d5
    lsl.l	#2,d3
    lsr.l	#2,d5
    or.l	d7,d3
    or.l	d0,d5
    
    move.l	d2,(a5)
    adda.w	a6,a5
    move.l	d3,(a5)
    adda.w	a6,a5
    move.l	d4,(a5)
    adda.w	a6,a5
    move.l	d5,(a5)
    adda.w	a6,a5
    
    move.l	a1,d7

    move.l	(a7)+,d1
    move.l	d1,d2
    move.l	(a7)+,d0
    move.l	d0,d3
    and.l	d7,d1
    and.l	d7,d3
    eor.l	d1,d2
    eor.l	d3,d0
    lsr.l	#8,d3
    lsl.l	#8,d2
    or.l	d3,d1
    or.l	d2,d0

    move.l	(a7)+,d5
    move.l	d5,d2
    move.l	(a7)+,d4
    and.l	d7,d5
    and.l	d4,d7
    eor.l	d5,d2
    eor.l	d7,d4
    lsr.l	#8,d7
    lsl.l	#8,d2
    or.l	d7,d5
    or.l	d2,d4

    move.l	a2,d7

    move.l	d4,d2
    move.l	d5,d3
    and.l	d7,d4
    and.l	d7,d3
    eor.l	d4,d2
    eor.l	d3,d5
    add.l	d4,d4
    lsr.l	#1,d5
    or.l	d3,d4
    or.l	d2,d5

    move.l	d0,d2
    and.l	d7,d0
    and.l	d1,d7
    eor.l	d0,d2
    eor.l	d7,d1
    add.l	d0,d0
    lsr.l	#1,d1
    or.l	d7,d0
    or.l	d2,d1

    swap	d0
    eor.w	d4,d0
    eor.w	d0,d4
    eor.w	d4,d0
    swap	d0

    swap	d1
    eor.w	d5,d1
    eor.w	d1,d5
    eor.w	d5,d1
    swap	d1

    move.l	a3,d7

    move.l	d4,d2
    move.l	d0,d3
    and.l	d7,d4
    and.l	d7,d3
    eor.l	d4,d2
    eor.l	d3,d0
    lsl.l	#2,d4
    lsr.l	#2,d0
    or.l	d3,d4
    or.l	d2,d0

    move.l	d5,d2
    and.l	d7,d5
    and.l	d1,d7
    eor.l	d5,d2
    eor.l	d7,d1
    lsl.l	#2,d5
    lsr.l	#2,d1
    or.l	d7,d5
    or.l	d2,d1
    
    move.l	d4,(a5)
    adda.w	a6,a5
    move.l	d5,(a5)
    adda.w	a6,a5
    move.l	d0,(a5)
    adda.w	a6,a5
    move.l	d1,(a5)
    
    movea.l	(a7)+,a5
    
    cmpa.l	(a7),a5
    
    blt		.loop
    
    adda.w	#4,a7
        
    movem.l	(a7)+,d2-d7/a2-a6

    rts
