
/* Interchange File Format */

#include <exec/types.h>

/* Additional error codes */

#define NOMEM  1
#define NOFILE 2

#define RGB(c) ((c) | ((c)<<8) | ((c)<<16) | ((c)<<24))

#define RowBytes(w) ((((w)+15)>>4)<<1)

/* Open IFF file/clip for reading/writing */

typedef struct IFFHandle IFFHandle;
typedef struct BitMapHeader BitMapHeader;
typedef struct BitMap BitMap;

IFFHandle *openIFF(STRPTR name, BOOL write, BOOL *clipOut, LONG *errOut);

/* Close IFF file/clip */

void closeIFF(IFFHandle *iff, BOOL clip);

/* Get BMHD and CAMG chunks, determine screen mode and color depth */

LONG parseILBM(IFFHandle *iff, BitMapHeader *bmhdOut);

BOOL findCAMG(IFFHandle *iff, ULONG *camgOut);

/* Get CMAP chunk, convert to palette */

BOOL findCMAP(IFFHandle *iff, ULONG **rgb32Out);

/* Read ILBM BODY chunk and unpack to BitMap with optional mask plane */

BOOL readILBM(IFFHandle *iff, BitMapHeader *bmhd, BitMap **bmOut);

/* TODO: Read 8SVX samples */

/* TODO: Read/write game data in IFF */

/* Future plan: Read ANIM animation and SMUS music */
