
/* RastPort (Layers and Windows) functions */

#include <exec/types.h>
#include <graphics/gfx.h>

#define Min(a, b) ( (a) < (b) ? (a) : (b) )
#define Max(a, b) ( (a) > (b) ? (a) : (b) )

typedef struct BitMap BitMap;
typedef struct RastPort RastPort;
typedef struct Layer Layer;
typedef struct Rectangle Rectangle;
typedef struct ClipRect ClipRect;

struct bltData
{
    BitMap *src, *back;
    WORD sx, sy;	
    WORD bx, by;
    BYTE shift; /* Positive value in range 0-15 */
};

struct wcpData
{
    UBYTE *buffer;
    WORD bpr;
};

/* Clip blitting operation */

void clipBlit(RastPort *rp, Rectangle *opRect, void (*blitOp)(RastPort *rp, Rectangle *rect, WORD ox, WORD oy, APTR data), APTR data);

/* Simple, fast rectangle region copy (16-pixel alignment required) */

void drawIconQuick(RastPort *rp, Rectangle *rect, WORD ox, WORD oy, struct bltData *data);

/* Draw aligned dual-layer icon with optional shifting to the right by "shift" value */

void drawDualIcon(RastPort *rp, Rectangle *rect, WORD ox, WORD oy, struct bltData *data);

/* Same as above, but shift to the left by "shift" value */

void drawDualIconLeft(RastPort *rp, Rectangle *rect, WORD ox, WORD oy, struct bltData *data);

void writeChunkyPixels(RastPort *rp, Rectangle *rect, WORD ox, WORD oy, struct wcpData *wcp);
